<template lang="pug">

  .container(v-loading="pageLoading")
    .activity__block(v-if='updatedNews')
      p.create-date-lable Обновлено {{ updatedNews }}
    .block-typical

      el-form(
        ref='newsForm'
        v-if="inputs.length"
        :model='stateForm'
        :rules="rules")

          el-form-item(
            prop='cover'
            style="margin-bottom: 35px")

            app-uploader(
              label="Обложка новости"
              :photo="news.cover"
              :uploadForm="uploadForm"
              :uploadFormHost="uploadFormHost"
              :readyToShip='readyToShip'
              @success-upload="successUpload"
              @remove-photo="removePhoto"
              @change-photo="changePhoto")

          el-form-item(
            v-for="item in inputs"
            :key="item.id"
            :style="item.maxWidth ? `max-width:${item.maxWidth}px; margin-bottom: 35px` : 'margin-bottom: 35px'"
            v-if='item.name !== "cover"'
            :prop="item.name")

            app-input(
              :placeholder="item.placeholder"
              :model="stateForm[item.name]"
              :name="item.name"
              :id="item.id"
              :label="item.label"
              :type="item.type"
              :prompt="item.prompt"
              :autosize="item.autosize"
              :maxlength="item.maxlength"
              :required="item.required"
              :uploadPath="`news/${news.slug}/`"
              :submitFunc="updateNews"
              :formRef="'newsForm'"
              @image-upload='uploadImage'
              @input-value="modelValue")

          app-editor-images(
            :photos="photos"
            :deleteLoading="dialogLoading"
            :dialogImageVisible='dialogDeleteVisible'
            @dialog-view='dialogViewEvent'
            @delete-image="deleteItemImage")

    .activity__block.reverse
      .activity__block-wrapper
        h5 Активность:
        el-switch(
          v-model='news.active'
          active-color="#39D24E"
          :active-value='true'
          :inactive-value='false')

    .activity__block
      router-link.el-button.el-button--info.button(
      :to="{path: '/admin/news'}")
        |Отмена

      el-button.button(
      type="success"
      @click="updateNews('newsForm')")
        |Сохранить изменения

</template>

<script>
import InputItem from '../../../components/InputItem';
import Uploader from '../../../components/admin/Uploader';
import EditorImages from '../../../components/admin/EditorImages';

export default {
  layout: 'admin',
  name: 'NewsItem',
  components: {
    'app-input': InputItem,
    'app-uploader': Uploader,
    'app-editor-images': EditorImages
  },
  async asyncData(context) {
    let { data } = await context.$axios.get(
      `/api/v1/news/${context.params.id}`
    );
    return { news: data };
  },
  data() {
    return {
      readyToShip: false,
      uploadForm: {
        path: `cover/news/${this.$route.params.id}`
      },
      uploadFormHost: `${this.$store.state.baseURL}/api/v1/img`,
      deletePhotoPath: '',
      dialogDeleteVisible: false,
      dialogLoading: false,
      inputs: [
        {
          id: 1,
          placeholder: 'Укажите заголовок новости',
          model: '',
          label: 'Заголовок',
          name: 'heading',
          required: true,
          prop: [
            {
              required: true,
              message: 'Пожалуйста, заполните поле',
              trigger: 'change'
            }
          ]
        },
        {
          id: 10,
          placeholder: '',
          model: '',
          label: 'Дата создания',
          name: 'created_at',
          type: 'datetime',
          maxWidth: '350px'
        },
        {
          id: 2,
          placeholder: 'Укажите описание новости',
          model: '',
          label: 'Короткое описание',
          name: 'description',
          type: 'textarea',
          autosize: { minRows: 1, maxRows: 20 },
          maxlength: 200,
          prompt: '<b>Максимальная длина:</b> 200 символов'
        },
        {
          id: 3,
          placeholder: 'Укажите текст новости',
          model: '',
          label: 'Текст новости',
          name: 'text',
          type: 'editor',
          required: true,
          prop: [
            {
              required: true,
              message: 'Пожалуйста, заполните поле',
              trigger: 'change'
            }
          ]
        },
        {
          id: 4,
          placeholder: '',
          model: '',
          label: 'Картинка',
          name: 'cover',
          required: true,
          prop: [
            {
              required: true,
              message: 'Пожалуйста, добавьте картинку',
              trigger: 'change'
            }
          ]
        }
      ],
      pageLoading: false,
      updatedNews: null,
      firstCover: false,
      photos: []
    };
  },
  computed: {
    stateForm() {
      let state = {};
      this.inputs.forEach(item => {
        state[item.name] = this.news[item.name];
      });
      return state;
    },
    rules() {
      let rulesObj = {};
      this.inputs.forEach(item => {
        rulesObj[item.name] = item.prop;
      });
      return rulesObj;
    }
  },
  created() {
    this.$store.commit('pages', [
      {
        name: 'Новости',
        slug: '/admin/news'
      }
    ]);
    this.$store.commit('headingTitle', 'Новость');
    this.$store.commit('publicLink', `/news/${this.news.slug}`);
    this.$store.commit('id', this.news.id);
  },
  mounted() {
    this.inputs.forEach(item => {
      item.model = this.news[item.name];
    });
    if (!this.news.cover) {
      this.firstCover = true;
    }
    this.photos = this.news.photos || [];
    if (this.news.updated_at) {
      this.updatedNews = `${this.$moment(this.news.updated_at).format(
        'D.MM.YY'
      )}, в ${this.$moment(this.news.updated_at).format('H:mm')}`;
    }
  },
  methods: {
    changePhoto(value) {
      this.news.cover = value;
    },
    dialogViewEvent(value) {
      this.dialogDeleteVisible = value;
    },
    removePhoto(value) {
      this.deletePhotoPath = value;
      this.news.cover = '';
    },
    successUpload(response) {
      if (response.photo) {
        this.$axios
          .patch(`/api/v1/news/${this.$route.params.id}`, {
            heading: this.stateForm.heading,
            description: this.stateForm.description,
            text: this.stateForm.text,
            cover: response.photo,
            photos: this.photos,
            active: this.news.active
          })
          .then(
            data => {
              this.news = data.data;
              if (this.deletePhotoPath) {
                this.$axios
                  .delete(`/api/v1/img?photo=${this.deletePhotoPath}`)
                  .then(
                    () => {
                      this.deletePhotoPath = '';
                      this.pageLoading = false;
                      this.$message.success('Новость успешно изменена!');
                    },
                    err => {
                      this.$message.error(err);
                    }
                  );
              } else {
                this.deletePhotoPath = '';
                this.pageLoading = false;
                this.$message.success('Новость успешно изменена!');
              }
            },
            errorMessage => {
              console.log(errorMessage);
              this.$message.error('Ошибка перезаписи данных!');
              this.pageLoading = false;
            }
          )
          .catch(() => {
            this.$message.error('Ошибка перезаписи данных');
            this.pageLoading = false;
          });
      }
    },
    deleteItemImage(value) {
      let photo = this.photos[value];
      this.dialogLoading = true;
      this.$axios
        .delete(`/api/v1/img?photo=${photo}`)
        .then(
          () => {
            this.photos.splice(value, 1);
            this.$axios
              .patch(`/api/v1/news/${this.$route.params.id}`, {
                heading: this.stateForm.heading,
                description: this.stateForm.description,
                text: this.stateForm.text,
                created_at: this.stateForm.created_at,
                photos: this.photos,
                active: this.news.active
              })
              .then(
                data => {
                  this.news.text = '';
                  this.news = data.data;
                  this.dialogDeleteVisible = false;
                  this.dialogLoading = false;
                  this.$message.warning('Фото удалено!');
                },
                errorMessage => {
                  console.log(errorMessage);
                  this.$message.error('Ошибка перезаписи данных!');
                }
              );
          },
          err => {
            this.$message.error(err);
          }
        )
        .catch(() => {
          this.$message.error('Ошибка перезаписи данных');
        });
    },
    uploadImage(value) {
      if (!this.photos.includes(value)) {
        this.photos.push(value);
      }
      if (this.deletePhotoPath || this.firstCover) {
        this.readyToShip = true;
      } else {
        this.$axios
          .patch(`/api/v1/news/${this.$route.params.id}`, {
            heading: this.stateForm.heading,
            description: this.stateForm.description,
            text: this.stateForm.text,
            created_at: this.stateForm.created_at,
            photos: this.photos,
            active: this.news.active
          })
          .then(
            data => {
              this.news = data.data;
              this.$message.success('Новость успешно изменена!');
            },
            errorMessage => {
              console.log(errorMessage);
              this.$message.error('Ошибка перезаписи данных!');
            }
          )
          .catch(() => {
            this.$message.error('Ошибка перезаписи данных');
          });
      }
    },
    modelValue(valueArr) {
      let index = this.inputs.findIndex(item => item.id === valueArr[0]);
      this.news[this.inputs[index].name] = valueArr[1];
    },
    updateNews(formName) {
      this.$refs[formName].validate(valid => {
        if (valid) {
          this.pageLoading = true;
          if (this.deletePhotoPath || this.firstCover) {
            this.readyToShip = true;
          } else {
            this.$axios
              .patch(`/api/v1/news/${this.$route.params.id}`, {
                heading: this.stateForm.heading,
                description: this.stateForm.description,
                text: this.stateForm.text,
                cover: this.stateForm.cover,
                created_at: this.stateForm.created_at,
                photos: this.photos,
                active: this.news.active
              })
              .then(
                () => {
                  this.pageLoading = false;
                  this.$message.success('Новость успешно изменена!');
                },
                errorMessage => {
                  console.log(errorMessage);
                  this.$message.error('Ошибка перезаписи данных!');
                  this.pageLoading = false;
                }
              )
              .catch(() => {
                this.$message.error('Ошибка перезаписи данных');
                this.pageLoading = false;
              });
          }
        } else {
          this.$message.error('Пожалуйста, заполните все обязательные поля!');
          return false;
        }
      });
    }
  }
};
</script>
